import React, { Fragment, useState } from 'react';
import { faUser, faCircle, faPlusCircle, faMagnet, faMoneyBillAlt, faAddressCard, faChartLine, faList, faClock, faSearch, faBell } from '@fortawesome/free-solid-svg-icons';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import { ArrowDropDown, ArrowLeft, ArrowRight, Search } from '@mui/icons-material';
import { Divider, AppBar, Toolbar, Box, InputBase, IconButton, List, ListItem, Button, Badge, Menu } from '@mui/material';

var styles = {"HeaderMenu":"_mPTDX","header-submenu":"_1DgrW","divider":"_2YDEp","right-arrow":"_24yDQ","left-arrow":"_7scc3","header-submenu-submenu":"_3TNvn","left":"_3NGmr","has-submenu":"_1A5fF","no-hover":"_3w4Ev","list-item":"_3j-vc","MenuIcon":"_3OG3N","list-item-label":"_3iPJy","badge":"_2vElT","intercom-lightweight-app":"_1NRCR","intercom-launcher-frame":"_18mlG","intercom-launcher-badge-frame":"_3uyl0","Header":"_1Wlv3","top-toolbar":"_2awhX","tpp-logo":"_d2vc-","submenu":"_1Z72J","submenu-list":"_1wV3M","button":"_3wODo","icon":"_20YJX","search":"_1X_uA","search-icon":"_2qLUO","menu-toolbar":"_1weYT","menu-list":"_1nTRF","svg":"_5jv_P","notyIframeMenu":"__PIKb","MuiPaper-root":"_1-FuY","BaseLayout":"_1VCrk","ag-header-icon":"_2Bjfs","ag-filter-icon":"_6QDpK","ag-header-cell-filtered":"_2pfPp"};

function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}

function r(e){var t,f,n="";if("string"==typeof e||"number"==typeof e)n+=e;else if("object"==typeof e)if(Array.isArray(e))for(t=0;t<e.length;t++)e[t]&&(f=r(e[t]))&&(n&&(n+=" "),n+=f);else for(t in e)e[t]&&(n&&(n+=" "),n+=t);return n}function clsx(){for(var e,t,f=0,n="";f<arguments.length;)(e=arguments[f++])&&(t=r(e))&&(n&&(n+=" "),n+=t);return n}

var iconConvert = [{
  id: 'fa fa-plus-circle',
  component: faPlusCircle
}, {
  id: 'fa fa-magnet',
  component: faMagnet
}, {
  id: 'fa fa-money',
  component: faMoneyBillAlt
}, {
  id: 'fa fa-address-card',
  component: faAddressCard
}, {
  id: 'fa fa-line-chart',
  component: faChartLine
}, {
  id: 'fa fa-list',
  component: faList
}, {
  id: 'fa fa-clock-o',
  component: faClock
}, {
  id: 'fa fa-search',
  component: faSearch
}];
var MenuIcon = function MenuIcon(_ref) {
  var _iconConvert$find;
  var menuItem = _ref.menuItem;
  var icon = (_iconConvert$find = iconConvert.find(function (i) {
    return i.id === (menuItem === null || menuItem === void 0 ? void 0 : menuItem.icon);
  })) === null || _iconConvert$find === void 0 ? void 0 : _iconConvert$find.component;
  if (!icon) {
    return '';
  }
  return /*#__PURE__*/React.createElement(FontAwesomeIcon, {
    size: "sm",
    icon: icon,
    className: styles['MenuIcon']
  });
};
var MenuListItemLink = function MenuListItemLink(_ref2) {
  var menuItem = _ref2.menuItem,
    leftAlignSubMenu = _ref2.leftAlignSubMenu;
  if (!menuItem) {
    return '';
  }
  if (menuItem.isLabel) {
    return menuItem.name;
  }
  return /*#__PURE__*/React.createElement("a", {
    href: "#" + menuItem.url,
    style: menuItem.hasSubMenu ? {
      paddingRight: 0
    } : {}
  }, menuItem.hasSubMenu && leftAlignSubMenu && /*#__PURE__*/React.createElement(ArrowLeft, {
    className: styles['left-arrow']
  }), /*#__PURE__*/React.createElement(MenuIcon, {
    menuItem: menuItem
  }), menuItem.name, ' ', menuItem.hasSubMenu && !leftAlignSubMenu && /*#__PURE__*/React.createElement(ArrowRight, {
    className: styles['right-arrow']
  }));
};
var MenuListItem = function MenuListItem(_ref3) {
  var id = _ref3.id,
    menuItem = _ref3.menuItem,
    children = _ref3.children,
    handleClick = _ref3.handleClick;
  if (menuItem.isDivider) {
    return /*#__PURE__*/React.createElement(Divider, {
      key: id,
      className: styles['divider']
    });
  }
  return menuItem.hasAccess && /*#__PURE__*/React.createElement("li", {
    onClick: function onClick(e) {
      return handleClick(e, menuItem);
    },
    className: clsx(styles['list-item'], menuItem.hasSubMenu && styles['has-submenu'], menuItem.isLabel && styles['list-item-label'])
  }, children);
};
var SubMenu = function SubMenu(_ref4) {
  var parentItem = _ref4.parentItem,
    subMenus = _ref4.subMenus,
    className = _ref4.className,
    handleClick = _ref4.handleClick;
  if (!subMenus || !subMenus.length) {
    return '';
  }
  return /*#__PURE__*/React.createElement("ul", {
    className: className
  }, subMenus.map(function (child, index) {
    var leftAlign = child.name === 'TPP Pay Merchant Portal';
    return /*#__PURE__*/React.createElement(MenuListItem, {
      key: index,
      id: index,
      menuItem: _extends({}, child, {
        parent: parentItem
      }),
      handleClick: handleClick
    }, /*#__PURE__*/React.createElement(MenuListItemLink, {
      menuItem: child,
      leftAlignSubMenu: leftAlign
    }), /*#__PURE__*/React.createElement(SubMenu, {
      id: index,
      parentItem: child,
      subMenus: child.subMenus,
      className: [styles['header-submenu-submenu'], leftAlign ? styles['left'] : ''].join(' '),
      handleClick: handleClick
    }));
  }));
};
var HeaderMenu = function HeaderMenu(_ref5) {
  var _user$firstName, _user$lastName;
  var item = _ref5.item,
    dueTaskCount = _ref5.dueTaskCount,
    user = _ref5.user,
    handleMenuClick = _ref5.handleMenuClick;
  var isNoHover = ['Task & Notes', 'TPPsales'].indexOf(item.name) > -1;
  var userInitials = [user === null || user === void 0 ? void 0 : (_user$firstName = user.firstName) === null || _user$firstName === void 0 ? void 0 : _user$firstName.charAt(0), user === null || user === void 0 ? void 0 : (_user$lastName = user.lastName) === null || _user$lastName === void 0 ? void 0 : _user$lastName.charAt(0)].filter(Boolean).join('');
  return /*#__PURE__*/React.createElement("li", {
    className: clsx(styles.HeaderMenu, isNoHover && styles['no-hover']),
    onClick: function onClick(e) {
      return handleMenuClick(e, item);
    }
  }, item.name === 'User' ? /*#__PURE__*/React.createElement(Fragment, null, /*#__PURE__*/React.createElement("span", {
    style: {
      position: 'absolute',
      top: '50%',
      left: '50%',
      transform: 'translate(-50%, -50%)',
      color: '#8f0526',
      fontSize: userInitials !== '' ? '18px' : '14px'
    }
  }, userInitials !== '' ? userInitials : /*#__PURE__*/React.createElement(FontAwesomeIcon, {
    id: "",
    icon: faUser,
    size: "2x"
  })), /*#__PURE__*/React.createElement(FontAwesomeIcon, {
    size: "3x",
    icon: faCircle
  })) : /*#__PURE__*/React.createElement(Fragment, null, /*#__PURE__*/React.createElement("span", null, item.name), item.hasSubMenu && /*#__PURE__*/React.createElement(ArrowDropDown, null)), /*#__PURE__*/React.createElement(SubMenu, {
    key: item.name,
    parentItem: item,
    subMenus: item.subMenus,
    className: styles['header-submenu'],
    handleClick: handleMenuClick
  }), item.name === 'Task & Notes' && (dueTaskCount != null ? dueTaskCount : 0) > 0 && /*#__PURE__*/React.createElement("span", {
    className: styles.badge
  }, dueTaskCount));
};

var Header = function Header(_ref) {
  var navItems = _ref.navItems,
    user = _ref.user,
    unreadMsgCount = _ref.unreadMsgCount,
    companyLogo = _ref.companyLogo,
    anchorEl = _ref.anchorEl,
    iframeURL = _ref.iframeURL,
    dueTaskCount = _ref.dueTaskCount,
    onShowIntercom = _ref.onShowIntercom,
    onShowNotification = _ref.onShowNotification,
    handleMenuClick = _ref.handleMenuClick,
    handleRedirectToLegacy = _ref.handleRedirectToLegacy,
    handleSearch = _ref.handleSearch,
    childComponent = _ref.childComponent;
  var _useState = useState(''),
    globalSearch = _useState[0],
    setGlobalSearch = _useState[1];
  var topNav = navItems.topNav,
    mainNav = navItems.mainNav;
  var companyLogoUrl = companyLogo ? companyLogo : 'https://totalpartyplanner.com/wp-content/themes/keyweb-tpp/img/logo-white.svg';
  var eSignImgUrl = 'https://app.totalpartyplanner.com/tppWebProd/images/toolbar-icons/esign.svg';
  var InterComImgUrl = 'https://app.totalpartyplanner.com/tppWebProd/images/toolbar-icons/intercom_icon.jpg';
  return /*#__PURE__*/React.createElement(AppBar, {
    position: "fixed",
    className: styles.Header
  }, /*#__PURE__*/React.createElement(Toolbar, {
    className: styles['top-toolbar'],
    disableGutters: true
  }, /*#__PURE__*/React.createElement("a", {
    href: "#",
    className: styles['tpp-logo'],
    onClick: function onClick(e) {
      return handleRedirectToLegacy('welcome.aspx');
    }
  }, /*#__PURE__*/React.createElement("img", {
    src: companyLogoUrl,
    alt: "logo"
  })), /*#__PURE__*/React.createElement(Box, {
    className: styles.submenu
  }, /*#__PURE__*/React.createElement(Box, {
    className: styles.search
  }, /*#__PURE__*/React.createElement(InputBase, {
    placeholder: "Search",
    inputProps: {
      'aria-label': 'search'
    },
    value: globalSearch,
    onKeyPress: function onKeyPress(e) {
      return e.key === 'Enter' && handleSearch(globalSearch);
    },
    onChange: function onChange(e) {
      return setGlobalSearch(e.target.value);
    }
  }), /*#__PURE__*/React.createElement(IconButton, {
    className: styles['search-icon'],
    onClick: function onClick() {
      return handleSearch(globalSearch);
    },
    style: {
      marginLeft: '-24px'
    }
  }, /*#__PURE__*/React.createElement(Search, null))), /*#__PURE__*/React.createElement(Box, null, topNav !== null && (topNav === null || topNav === void 0 ? void 0 : topNav.length) > 0 && /*#__PURE__*/React.createElement(List, {
    className: styles['submenu-list']
  }, /*#__PURE__*/React.createElement(ListItem, null, /*#__PURE__*/React.createElement(Button, {
    onClick: function onClick(e) {
      return onShowNotification(e.currentTarget);
    },
    className: styles.button
  }, /*#__PURE__*/React.createElement(Badge, {
    badgeContent: unreadMsgCount,
    color: "primary",
    max: 99
  }, /*#__PURE__*/React.createElement(FontAwesomeIcon, {
    className: styles.icon,
    icon: faBell
  }))), /*#__PURE__*/React.createElement(Menu, {
    anchorEl: anchorEl,
    className: styles.notyIframeMenu,
    open: Boolean(anchorEl),
    onClose: function onClose() {
      return onShowNotification(null);
    }
  }, /*#__PURE__*/React.createElement("iframe", {
    id: "notyIframe51096",
    src: iframeURL,
    height: "600",
    width: "400"
  }))), /*#__PURE__*/React.createElement(ListItem, {
    className: styles.HeaderMenu,
    onClick: function onClick() {
      return window.open(window.location);
    }
  }, /*#__PURE__*/React.createElement("span", null, "New Browser")), topNav === null || topNav === void 0 ? void 0 : topNav.map(function (menuElement, index) {
    return /*#__PURE__*/React.createElement(HeaderMenu, {
      key: index,
      item: menuElement,
      dueTaskCount: dueTaskCount,
      user: user,
      handleMenuClick: handleMenuClick
    });
  }))))), /*#__PURE__*/React.createElement(Toolbar, {
    className: styles['menu-toolbar'],
    disableGutters: true
  }, mainNav !== null && (mainNav === null || mainNav === void 0 ? void 0 : mainNav.length) > 0 && /*#__PURE__*/React.createElement(List, {
    className: styles['menu-list']
  }, mainNav === null || mainNav === void 0 ? void 0 : mainNav.map(function (menuElement, index) {
    return /*#__PURE__*/React.createElement(HeaderMenu, {
      key: index,
      item: menuElement,
      dueTaskCount: dueTaskCount,
      user: user,
      handleMenuClick: handleMenuClick
    });
  })), /*#__PURE__*/React.createElement(Box, {
    ml: 'auto'
  }, /*#__PURE__*/React.createElement("a", {
    href: "#",
    onClick: function onClick() {
      return handleRedirectToLegacy('welcome.aspx?launch=esign');
    }
  }, /*#__PURE__*/React.createElement("img", {
    className: styles.svg,
    src: eSignImgUrl
  })), /*#__PURE__*/React.createElement("a", {
    id: "liIntercom",
    href: "#",
    onClick: onShowIntercom
  }, /*#__PURE__*/React.createElement("img", {
    style: {
      marginRight: 8,
      width: 33
    },
    src: InterComImgUrl,
    alt: "Intercom"
  })))), childComponent);
};

var ToolbarComponent = function ToolbarComponent(_ref) {
  var navItems = _ref.navItems,
    unreadMsgCount = _ref.unreadMsgCount,
    iframeURL = _ref.iframeURL,
    dueTaskCount = _ref.dueTaskCount,
    anchorEl = _ref.anchorEl,
    companyLogo = _ref.companyLogo,
    user = _ref.user,
    onShowIntercom = _ref.onShowIntercom,
    onShowNotification = _ref.onShowNotification,
    handleMenuClick = _ref.handleMenuClick,
    handleRedirectToLegacy = _ref.handleRedirectToLegacy,
    handleSearch = _ref.handleSearch,
    childComponent = _ref.childComponent;
  return /*#__PURE__*/React.createElement("div", {
    className: styles.BaseLayout
  }, /*#__PURE__*/React.createElement(Header, {
    navItems: navItems,
    unreadMsgCount: unreadMsgCount,
    anchorEl: anchorEl,
    iframeURL: iframeURL,
    companyLogo: companyLogo,
    dueTaskCount: dueTaskCount,
    user: user,
    onShowIntercom: onShowIntercom,
    onShowNotification: onShowNotification,
    handleMenuClick: handleMenuClick,
    handleRedirectToLegacy: handleRedirectToLegacy,
    handleSearch: handleSearch,
    childComponent: childComponent
  }));
};

export { ToolbarComponent };
//# sourceMappingURL=index.modern.js.map
